package org.foxarmy.barcodescannerforemployees

import android.content.Context
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.util.Log
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import android.widget.Toast
import java.io.File

/**
 * TODO: document your custom view class.
 */
class AbstractProductView: LinearLayout {
    private val productImage = ImageView(context)
    private val productNameField = TextView(context)
    private val netWeightField = TextView(context)
    private val categoryField = TextView(context)


    constructor(context: Context, productImageFile: String, productName: String, netWeight: Double, category: Int) : super(context) {
        this.orientation = LinearLayout.VERTICAL

        val imageFile = File(File(context.filesDir, "pictures"), productImageFile)
        val image: ByteArray = imageFile.readBytes()

        if (image.isEmpty()) {
            Toast.makeText(context, image.size.toString(), Toast.LENGTH_LONG).show()
        }
        try {
            Log.d("org.foxarmy.barcodescannerforemployees", "[ХУЙ]" + imageFile.absolutePath)
            val bitmap: Bitmap = BitmapFactory.decodeFile(imageFile.absolutePath)
        } catch (e:Exception) {
            Log.d("org.foxarmy.barcodescannerforemployees", "[ХУЙ] " + e)
        }
//        productImage.setImageBitmap(bitmap)
        productNameField.setText(productName)
        netWeightField.setText(netWeight.toString())

        addView(productNameField)
        addView(netWeightField)

//        if(findViewById(R.id.productLayout) == null) {
//            Toast.makeText(context, "AAAAAAAAAAA", Toast.LENGTH_LONG).show()
//        }

//        findViewById<ConstraintLayout>(R.id.productLayout).addView(productNameField)
//        (requestLayout() as RelativeLayout).addView(productNameField)

    }
}

//class AbstractProductView : View {
//
//    private var _exampleString: String? = null // TODO: use a default from R.string...
//    private var _exampleColor: Int = Color.RED // TODO: use a default from R.color...
//    private var _exampleDimension: Float = 0f // TODO: use a default from R.dimen...
//
//    private lateinit var textPaint: TextPaint
//    private var textWidth: Float = 0f
//    private var textHeight: Float = 0f
//
//    /**
//     * The text to draw
//     */
//    var exampleString: String?
//        get() = _exampleString
//        set(value) {
//            _exampleString = value
//            invalidateTextPaintAndMeasurements()
//        }
//
//    /**
//     * The font color
//     */
//    var exampleColor: Int
//        get() = _exampleColor
//        set(value) {
//            _exampleColor = value
//            invalidateTextPaintAndMeasurements()
//        }
//
//    /**
//     * In the example view, this dimension is the font size.
//     */
//    var exampleDimension: Float
//        get() = _exampleDimension
//        set(value) {
//            _exampleDimension = value
//            invalidateTextPaintAndMeasurements()
//        }
//
//    /**
//     * In the example view, this drawable is drawn above the text.
//     */
//    var exampleDrawable: Drawable? = null
//
//    constructor(context: Context) : super(context) {
//        init(null, 0)
//    }
//
//    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {
//        init(attrs, 0)
//    }
//
//    constructor(context: Context, attrs: AttributeSet, defStyle: Int) : super(context, attrs, defStyle) {
//        init(attrs, defStyle)
//    }
//
//    private fun init(attrs: AttributeSet?, defStyle: Int) {
//        // Load attributes
//        val a = context.obtainStyledAttributes(
//            attrs, R.styleable.AbstractProductView, defStyle, 0
//        )
//
//        _exampleString = a.getString(
//            R.styleable.AbstractProductView_exampleString
//        )
//        _exampleColor = a.getColor(
//            R.styleable.AbstractProductView_exampleColor,
//            exampleColor
//        )
//        // Use getDimensionPixelSize or getDimensionPixelOffset when dealing with
//        // values that should fall on pixel boundaries.
//        _exampleDimension = a.getDimension(
//            R.styleable.AbstractProductView_exampleDimension,
//            exampleDimension
//        )
//
//        if (a.hasValue(R.styleable.AbstractProductView_exampleDrawable)) {
//            exampleDrawable = a.getDrawable(
//                R.styleable.AbstractProductView_exampleDrawable
//            )
//            exampleDrawable?.callback = this
//        }
//
//        a.recycle()
//
//        // Set up a default TextPaint object
//        textPaint = TextPaint().apply {
//            flags = Paint.ANTI_ALIAS_FLAG
//            textAlign = Paint.Align.LEFT
//        }
//
//        // Update TextPaint and text measurements from attributes
//        invalidateTextPaintAndMeasurements()
//    }
//
//    private fun invalidateTextPaintAndMeasurements() {
//        textPaint.let {
//            it.textSize = exampleDimension
//            it.color = exampleColor
//            textWidth = it.measureText(exampleString)
//            textHeight = it.fontMetrics.bottom
//        }
//    }
//
//    override fun onDraw(canvas: Canvas) {
//        super.onDraw(canvas)
//
//        // TODO: consider storing these as member variables to reduce
//        // allocations per draw cycle.
//        val paddingLeft = paddingLeft
//        val paddingTop = paddingTop
//        val paddingRight = paddingRight
//        val paddingBottom = paddingBottom
//
//        val contentWidth = width - paddingLeft - paddingRight
//        val contentHeight = height - paddingTop - paddingBottom
//
//        exampleString?.let {
//            // Draw the text.
//            canvas.drawText(
//                it,
//                paddingLeft + (contentWidth - textWidth) / 2,
//                paddingTop + (contentHeight + textHeight) / 2,
//                textPaint
//            )
//        }
//
//        // Draw the example drawable on top of the text.
//        exampleDrawable?.let {
//            it.setBounds(
//                paddingLeft, paddingTop,
//                paddingLeft + contentWidth, paddingTop + contentHeight
//            )
//            it.draw(canvas)
//        }
//    }
//}