package org.foxarmy.barcodescannerforemployees

//import com.google.mlkit.vision.codescanner.GmsBarcodeScannerOptions
import android.os.Build
import android.os.Bundle
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.activity.result.contract.ActivityResultContracts
import androidx.annotation.RequiresApi
import androidx.core.content.FileProvider
import androidx.fragment.app.Fragment
import com.google.firebase.components.BuildConfig
import org.foxarmy.barcodescannerforemployees.databinding.AddProductFragmentBinding
import java.io.File
import java.security.MessageDigest


@OptIn(ExperimentalStdlibApi::class)
fun String.md5(): String {
    val md = MessageDigest.getInstance("MD5")
    val digest = md.digest(this.toByteArray())
    return digest.toHexString()
}

class AddProductFragment : Fragment() {

    private var _binding: AddProductFragmentBinding? = null
    private val binding get() = _binding!!

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        _binding = AddProductFragmentBinding.inflate(inflater, container, false)
        return binding.root
    }

    val takePicture = registerForActivityResult(ActivityResultContracts.TakePicture()) { success: Boolean ->
        if (success) {
            Log.i("QWERTYUIOP", "Done")
        } else {
            Log.e("QWERTYUIOP", "Xuinya")
        }
    }

    fun getPicture () {
        val imageFile = File(requireContext().filesDir, "image.png")
        val imageUri = FileProvider.getUriForFile(requireActivity(), BuildConfig.APPLICATION_ID + "." + requireActivity().localClassName + ".provider", imageFile)
        takePicture.launch(imageUri)
    }

    val requestPermissionLauncher =
        registerForActivityResult(
            ActivityResultContracts.RequestPermission()
        ) { isGranted: Boolean ->
            if (isGranted) {
                Toast.makeText(requireContext(), "Granted", Toast.LENGTH_LONG).show()
//                getFuckingPicture()
            } else {
                Toast.makeText(requireContext(), "I need permission in order to take a picture", Toast.LENGTH_LONG).show()
            }
        }

    @RequiresApi(Build.VERSION_CODES.R)
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        binding.takePictureButton.setOnClickListener {
//            requestPermissionLauncher.launch(android.Manifest.permission.CAMERA)
            try {
                getPicture()

            } catch (e:Exception) {
                Log.e("QWERTYUIOP", e.message.toString())
            }

//            try {
//                when{
//                    ContextCompat.checkSelfPermission(requireContext(), android.Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED -> {
//                        getFuckingPicture()
//                    } else -> {
////                    requestPermissionLauncher.launch(android.Manifest.permission.WRITE_EXTERNAL_STORAGE)
////                    ActivityCompat.requestPermissions(requireActivity(), arrayOf(android.Manifest.permission.WRITE_EXTERNAL_STORAGE), 200)
//
//                    Log.e("QWERTYUIOP", "хуй соси губой тряси")
//                    }
//                }
//
//            } catch (e:Exception) {
//                Log.e("QWERTYUIOP",  e.message.toString())
//            }
        }
/*
        binding.saveButton.setOnClickListener {
            val productName = binding.productName.text.toString()
            val netWeight = binding.netWeight.text
            if (picture == null) {
                Toast.makeText(context, "Please, make a picture of a product!", Toast.LENGTH_SHORT).show()
                return@setOnClickListener
            }
            if (productName == "") {
                Toast.makeText(context, "Please, write a name of a product!", Toast.LENGTH_SHORT).show()
                return@setOnClickListener
            }
            if (netWeight.toString() == "" || netWeight.toString().toDoubleOrNull() == null) {
                Toast.makeText(context, "Please, write a valid net weight of a product!", Toast.LENGTH_SHORT).show()
            }

            val appFiles = context?.filesDir
            val picturesDir = File(appFiles, "pictures")
            picturesDir.mkdirs()
            val imageFilename = picture.toString().md5() + ".png"
            val imageFile = File(picturesDir, imageFilename)
            val stream = FileOutputStream(imageFile)
            picture!!.compress(Bitmap.CompressFormat.PNG, 100, stream)

            stream.use {
                val buffer = ByteBuffer.allocate(picture!!.byteCount)
                picture!!.copyPixelsToBuffer(buffer)
                it.write(buffer.array())
            }

            val db = DBStorageController(requireContext()).writableDatabase

            val values = ContentValues().apply {
                put(ProductContract.ProductEntry.PRODUCT_NAME, productName)
                put(ProductContract.ProductEntry.PRODUCT_NET_WEIGHT, netWeight.toString())
                put(ProductContract.ProductEntry.IMAGE_FILENAME, imageFilename)
            }

            db.insert(ProductContract.ProductEntry.TABLE_NAME, null, values)
        }

        binding.takePictureButton.setOnClickListener {

            requestPermissionLauncher.launch(android.Manifest.permission.CAMERA)

//            val imageUri: Uri = Uri.fromFile(File(File(context?.filesDir, "pictures"), "test.jpg"))
//            val imageUri = Uri.parse("pictures/test.jpg")
//            val picturesDir = File(context?.filesDir, "pictures")
//            picturesDir.mkdirs()
//            val uri = Uri.fromFile(File(picturesDir, "test.jpg"))
//            Log.d("", uri.toString())
//            takePicture.launch(uri)
        }

        binding.scanButton.setOnClickListener {
            val options = GmsBarcodeScannerOptions.Builder()
                .setBarcodeFormats(
                    Barcode.FORMAT_EAN_13
                )
                .build()
            val scanner = GmsBarcodeScanning.getClient(requireContext())
            scanner.startScan()
                .addOnSuccessListener { barcode ->
                    binding.productName.setText(barcode.rawValue)

//                    val url = URL()
                }
                .addOnFailureListener { e ->
                    Toast.makeText(
                        requireContext(),
                        "Failed to scan barcode. Please, try again or enter data manually",
                        Toast.LENGTH_LONG
                    ).show()
                }
        }
        */
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }
}